import * as THREE from './libs/three.js-r132/build/three.module.js';
//import { MindARThree } from './libs/mindar/mindar-image-three.prod.js"';
//const THREE = window.MINDAR.IMAGE.THREE;
document.addEventListener('DOMContentLoaded',onDOMContentLoaded);
import {loadGLTF, loadAudio, loadVideo} from "./libs/loader.js";
import {createChromaMaterial} from './libs/chroma-video.js';

let xrRefSpace = null;

//const sample01 = Symbol('sebuahsimbol');

function onDOMContentLoaded(){
    console.log("onDOMContentLoaded()->check 1 Start System");
    initialize();
}

async function initialize(){
    //mindar dulu buat ngawalan //////
    console.log("initialize()->check 1 wow bisa");

    const mindarThree = new window.MINDAR.IMAGE.MindARThree({
        container: document.body,
        imageTargetSrc: './qr-yogyakarta.mind',
        uiScanning: "#scanning",
        uiLoading: "no",



      });
    
      const {renderer, scene, camera} = mindarThree;

      renderer.setSize(window.innerWidth, window.innerHeight);

      // create AR object
    const geometry = new THREE.PlaneGeometry(1, 1);
    const material = new THREE.MeshBasicMaterial({color: 0x00ffff, transparent: true, opacity: 0.5});
    const plane = new THREE.Mesh(geometry, material);


      // create anchor
    const anchor = mindarThree.addAnchor(0);
   // anchor.group.add(plane);

    
    // start AR
    await mindarThree.start();
    
    renderer.setAnimationLoop(() => {
      renderer.render(scene, camera);
    });


    const starthere = await loadGLTF("./TombolStart.glb"); 
    
    starthere.scene.scale.set(0.05,0.05,0.05);
    starthere.scene.position.set(0,-0.6,0);
    starthere.scene.userData.clickable = true;//parameter ditambahkan supaya untuk deteksi interactive nya

    anchor.group.add(starthere.scene);
    const light = new THREE.HemisphereLight(0xffffff, 0xbbbbff,1);
    scene.add(light);
      /////////////////////////////////////////////////////
   
//////////////////////////
//listener target tracking found and lost// pas detect dan pas lepas deteksi
anchor.onTargetFound = onTargetFounded;
anchor.onTargetLost = onLostTarget;


      
const audiolistener1 = new THREE.AudioListener();
camera.add(audiolistener1);
const audioClip00 = await loadAudio("./telegram.mp3");
const clickAudioFX1 = new THREE.Audio(audiolistener1);
clickAudioFX1.setBuffer(audioClip00);


const audiolistener2 = new THREE.AudioListener();
camera.add(audiolistener2);
const audioClip02 = await loadAudio("./pixel.mp3");
const clickAudioFX2 = new THREE.Audio(audiolistener2);
clickAudioFX2.setBuffer(audioClip02);


function onTargetFounded(){
    console.log ("target found");
    //audio.play();
    //chromavideo.play();
    //moveToWebXR();
    clickAudioFX1.play();
};
function onLostTarget(){
    console.log("target lost");
    //audio.stop();
    //chromavideo.pause();
  
    setTimeout(() => { return mindarThree.ui.showScanning() }, 2000)
       
}
//////////////////////////
     





    

    let currentSession =null;
    /*
    const supported = navigator.xr.isSessionSupported('immersive-ar');
    if(supported){
       // arButton.innerHTML = 'Enter AR Ruly';
       //startWebXR();
    }else{
       // arButton.innerHTML = 'AR Not Supported';
    }
    //arButton.disabled = !supported;
    //arButton.addEventListener("click", onARButtonClicked);
        //*/
    
        console.log("init()->check 2");
      
    ///////////membuat interaksi klik tombol start here

    document.body.addEventListener("click", onDocumentClicked);
    function onDocumentClicked(e){
        //konversinya masi problem
        //mendapatkan titik mouse nya atau titik sentunya konversinya sepertio ini
        const mouseX = (e.clientX/window.innerWidth)*2-1;
        const mouseY = -1*((e.clientY/window.innerHeight)*2-1);
        const mouse = new THREE.Vector2(mouseX, mouseY);
         //DOM element dari Top ke bottom sementara di kanvas dari bottom ke top jadi di kali dengan -1 untk di reverse atau dibalik
        //menggunakan raycaster untuk simulasi mana yg intersect model atau ke klik
        const raycaster = new THREE.Raycaster();
        raycaster.setFromCamera(mouse, camera);
        const intersectObjects = raycaster.intersectObjects(scene.children, true);// multiple object semua yg ada di scene bisa di periksa intersect dengan raycaster
   

        if(intersectObjects.length > 0){
            console.log("onDocumentClicked()-> Raicaster is interct with object, one or more --  CHECK 2");
            let obj = intersectObjects[0].object;//memilih object paling dekat ke kamera
            //mencari object yg dimaksud
            while(obj.parent&& !obj.userData.clickable){
                obj = obj.parent;
                /*
                if(obj===gltf.scene) break;
                obj = obj.parent;*/
            }
            if(obj.userData.clickable){


            console.log("onDocumentClicked()-> object is clickable--  CHECK 3");
            //clickAudioFX.play();
                if(obj === starthere.scene){
                    console.log("onDocumentClicked()-> object is StartHere SCENE--  CHECK 4");
                        //clickAudioFX.play();
                        //playWebXR();
                        mindarThree.stop();
                        //supaya berhenti yg mindar renderer nya
                       renderer.setAnimationLoop(null);
                       mindarThree.ui.showScanning = false;
                       clickAudioFX2.play(); 
                       startWebXR();

                }

            }

        }
    }

    const arButton = document.querySelector("#tombolar");
    const supported = navigator.xr.isSessionSupported('immersive-ar');
    if(supported){
        arButton.innerHTML = 'Enter AR Ruly';
    }else{
        arButton.innerHTML = 'AR Not Supported';
    }
    arButton.disabled = !supported;
    arButton.addEventListener("click", onARButtonClicked);
    //arButton.display = none;

    
    function onARButtonClicked(){
        if(currentSession){
            //endWebXR();
        }else{

            moveToWebXR();
        }
    }

    function moveToWebXR(){
        mindarThree.stop();
        //supaya berhenti yg mindar renderer nya
       renderer.setAnimationLoop(null);
        startWebXR();
    }
    /*
    let WEBXRButton = document.getElementById('webxr').addEventListener('click',()=>{
        console.log("startwebxr()->WebXR Button Clicked()////////////////////////");
        startWebXR();
    }

  );
    //*/




 
    async function startWebXR(){
        console.log("startwebxr()->check 1 Apakah Berjalan!!");


          //////////Scene untuk WebXR///////////////////
          const sceneWebXR    = new THREE.Scene(); 
          const cameraWebXR   = new THREE.PerspectiveCamera(80, window.innerWidth / window.innerHeight, 0.001, 1000  );
          //camera = cameraWebXR;
          //const rendererWebXR = new THREE.WebGLRenderer({alpha:false});
          const rendererWebXR = new THREE.WebGLRenderer({alpha:true,preserveDrawingBuffer: true});
          ///////////Scene WebXR Done/////////////
  
          ///// set renderer displaying ///////////// 
          rendererWebXR.setSize(window.innerWidth, window.innerHeight);
          rendererWebXR.setPixelRatio(window.devicePixelRatio);
          document.body.appendChild(rendererWebXR.domElement);
          ////////////////////////////////
  
          
          const geometry = new THREE.PlaneGeometry(1,1); //membuat geometry 1,1
              const material = new THREE.MeshBasicMaterial({color: 0xFF0000, transparent: true, opacity: 1 });
              const plane = new THREE.Mesh(geometry, material);
          
          //memposisikan plane
          plane.rotation.x = 0;// Math.PI/2;
          plane.position.y = 0;
          plane.position.z = -2.6;
  
         // sceneWebXR.add(plane);
  
          console.log("init()->check 3");
          
            ///// tambahan untuk cam capture///
           // var particles = 20*10*150;
           const light2 = new THREE.PointLight( 0xffffff,1.5 );
           light2.decay = 1
           light2.distance = 30;
           light2.position.x = 0
           light2.position.y = 1.5
           light2.position.z = 0.5
           sceneWebXR.add(light2);
   
           var ambient = new THREE.AmbientLight(0x222222);
           sceneWebXR.add(ambient);
   
           /////////menambah object gltf
            //membuat loading object 3d
           //const pejuang = await loadGLTF("./scene.gltf");
           const pejuang = await loadGLTF("./keretapejuang.glb");

           //mengeset supaya model pas di tempatnya
          //tiap model punya masalah beda2 supaya pas ditempatnya
          pejuang.scene.scale.set(1,1,1);
          pejuang.scene.position.set(0,-1.4,-2);
          //raccoon.scene.userData.clickable = true;//parameter ditambahkan supaya untuk deteksi interactive nya
   
          //anchor.group.add(raccoon.scene);
          sceneWebXR.add(pejuang.scene);
          rendererWebXR.setAnimationLoop(animationLoopActionXR);
          function animationLoopActionXR(){
              //console.log("startwebxr()animationLoopAction->check 1");
              rendererWebXR.render(sceneWebXR,cameraWebXR);
          }


        console.log("startwebxr()->check 2");
        
        ////////////script memanggil sesi webXR /////////////////////////
        //ketika session ar semua DOM Element hilang, supaya bisa overlay DOM Eelement AR Button caranya adalah
        //meminta fitur tambahan yaitu parameter optionalFeature tersebut 'dom-overlay'
        
        //TAMBAHAN DARI RULY
       // const sessionOptions = { requiredFeatures:[], optionalFeatures[],};
        
       const sessionOptions = {
        requiredFeatures: [],
        optionalFeatures: [],
      };

        //sessionOptions.requiredFeatures.push('camera-access');
        sessionOptions.requiredFeatures.push('dom-overlay');
        sessionOptions.domOverlay = { root: document.body };
        //////////////////////////
        //currentSession = await navigator.xr.requestSession('immersive-ar', sessionOptions).then(onSessionStarted, onRequestSessionError);
        //currentSession = await navigator.xr.requestSession('immersive-ar', sessionOptions).then(onSessionStarted);
        /*
        navigator.xr.requestSession('immersive-ar', sessionOptions)
        .then(onSessionStarted, onRequestSessionError);
        */

        console.log("startwebxr()->check 3");
        currentSession = await navigator.xr.requestSession('immersive-ar', sessionOptions);

       // currentSession = await navigator.xr.requestSession('immersive-ar', {optionalFeatures: ['dom-overlay'], domOverlay: {root: document.body}});
        rendererWebXR.xr.enabled = true;
        rendererWebXR.xr.setReferenceSpaceType('local');//location of we start XR session  is the center of virtual space
        await rendererWebXR.xr.setSession(currentSession);
       // chromavideo.play();
      

        ///////////////////////////////////////////////////////////
        console.log("startwebxr()->check 3,5");
        //*
        
            //*/

         /// tambahan untuk screen capture
         console.log("startwebxr()->check 4");
        
        

            const audiolistener = new THREE.AudioListener();
            cameraWebXR.add(audiolistener);
            const audioClip01 = await loadAudio("./steamtrainpass.mp3");
            const clickAudioFX = new THREE.Audio(audiolistener);
            clickAudioFX.setBuffer(audioClip01);
            clickAudioFX.play();



         currentSession.requestReferenceSpace('local').then((refSpace)=>{
            xrRefSpace = refSpace;
         
            console.log("startwebxr()->check 2A");

         });
         console.log("startwebxr()->check 5");
         let count = 0;
         
         
         function render(){
            rendererWebXR.render(sceneWebXR,cameraWebXR);
         }

         ///////////////////////////////////////////////////////////////

    }


    async function endWebXR(){
        //currentSession.end();
        //rendererWebXR.clear();
        //rendererWebXR.setAnimationLoop(null);
        arButton.style.display = "none";
    }
}